﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace typingCS {
    public partial class FontForm : Form {
        static bool protect;
        public byte eng;
        public bool lmode;
        public byte size;
        public bool bold;
        public bool mincho;
        public bool[]msfont;
        public bool prop;

        public FontForm() { InitializeComponent(); }

        public void SetDialog() {
            int i;
            protect=true;
            MainForm.DlgSz=3+(MainForm.MsMenu[lmode?1:0]?1:0)+(lmode?0:1);
            MainForm.DlgWidth=MainForm.DLG_FONT_WIDTH;
            MainForm.DlgLabel=MainForm.DLG_SIZE_LABEL;
            MainForm.DlgBase=MainForm.DLG_MARGIN_TOP;
            MainForm.DlgCombo=MainForm.DLG_FONT_NUM;
            MainForm.DlgCnt=0;
            for (i=0;i<MainForm.FONT_SIZE_TBL.Length; i++)
                SizeCombo.Items.Add(MainForm.FONT_SIZE_TBL[i].ToString());
            for (i=0;i<MainForm.FONT_SIZE_TBL.Length-1;i++)
                if (MainForm.FONT_SIZE_TBL[i]==size) break;
            this.SizeCombo.SelectedIndex=i;
            this.SizeCombo.Font=MainForm.FontDlg;
            this.BoldCheck.Checked=bold;
            this.BoldCheck.Font=MainForm.FontDlg;
            this.MinchoCheck.Checked=mincho;
            this.MinchoCheck.Font=MainForm.FontDlg;
            if (lmode) {
                int g=this.mincho?1:0;
                this.MsCheck.Checked=msfont[g+4];
                this.MsCheck.Enabled=MainForm.MsExist[g]&&MainForm.UmeExist[g];
                this.Text="配列フォント";
                this.PropCheck.Visible=false;
            } else {
                int g=(prop?2:0)+(this.mincho?1:0);
                this.MsCheck.Checked=msfont[g];
                this.MsCheck.Enabled=MainForm.MsExist[g]&&MainForm.UmeExist[g];
                this.Text="例題フォント";
                this.PropCheck.Visible=true;
                this.PropCheck.Checked=prop;
            }
            MainForm.MyNumDlg(SizeCombo,SizeLabel);
            MainForm.MyDlg(BoldCheck);
            MainForm.MyDlg(MinchoCheck);
            if (MainForm.MsMenu[lmode?1:0]) MainForm.MyDlg(MsCheck); else MsCheck.Visible=false;
            if (!lmode) MainForm.MyDlg(PropCheck); else PropCheck.Visible=false;
            MainForm.OkCancel(this,MainForm.DlgBase+((MainForm.DlgSz+1)/2)*MainForm.DLG_INTERVAL,FontOkButton,FontCancelButton);
            protect=false;
        }

        private void OkButton_Click(object sender, EventArgs e) {
            size=MainForm.FONT_SIZE_TBL[SizeCombo.SelectedIndex];
            bold=this.BoldCheck.Checked;
            mincho=this.MinchoCheck.Checked;
            if (lmode) msfont[4+(mincho?1:0)]=this.MsCheck.Checked;
            else {
                prop=this.PropCheck.Checked;
                msfont[(prop?2:0)+(mincho?1:0)]=this.MsCheck.Checked;
            }
        }

        private void MinchoCheck_CheckedChanged(object sender, EventArgs e) {
            if (protect) return;
            bool prev=mincho; int g;
            mincho=MinchoCheck.Checked;
            if (prev!=mincho) {
                if (lmode) {
                    msfont[4+(prev?1:0)]=this.MsCheck.Checked;
                    g=(mincho?1:0);
                    this.MsCheck.Checked=msfont[4+g];
                    this.MsCheck.Enabled=MainForm.MsExist[g]&&MainForm.UmeExist[g];
                } else {
                    msfont[(prop?2:0)+(prev?1:0)]=this.MsCheck.Checked;
                    g=(prop?2:0)+(mincho?1:0);
                    this.MsCheck.Checked=msfont[g];
                    this.MsCheck.Enabled=MainForm.MsExist[g]&&MainForm.UmeExist[g];
                }
            }
        }

        private void PropCheck_CheckedChanged(object sender, EventArgs e) {
            if (protect) return;
            bool prev=prop; int g;
            if (lmode) return;
            prop=PropCheck.Checked;
            if (prev!=prop) {
                msfont[(prev?2:0)+(mincho?1:0)]=this.MsCheck.Checked;
                g=(prop?2:0)+(mincho?1:0);
                this.MsCheck.Checked=msfont[g];
                this.MsCheck.Enabled=MainForm.MsExist[g]&&MainForm.UmeExist[g];
            }
        }
    }
}
