#include <windows.h>

#define NAME "Mizunara"

UCHAR MIZU_STR[]=
"d'v d[u d]v "
"q  w  e  r  t  y  u  i  o  p  a  f  g  h  "
"j  ;  z  x  c  v  b  n  m  kq kw ke kr kt "
"ka ks kd kf kg kz kx kc kv kb dy du di do "
"dp d@u dh dj dk dl d; d:v dn dm d, d. d/ lq "
"lw le lr lt la ls ld lf lg lz lx lc lv lb "
"su si so sp sh sj[ sk sl s; sn sm s, s. s/ ";

UCHAR ROMA_STR[]=
"-[     a     ba    be    bi    bo    bu    byaт byeт "
"byiт byoт byuт ca    ce    cha che chi   cho "
"chu ci    co    cu    cya cye cyi cyo cyu "
"da    de    dhał dheł dhił dhoł dhuł di    do    "
"du    dwaǂ dweǂ dwiǂ dwoǂ dwuǂ dya dye dyi "
"dyo dyu e     faӂ  feӂ  fiӂ  foӂ  fu    fwaӂ "
"fweӂ fwiӂ fwoӂ fwuӂ fyaӂ fyeӂ fyiӂ fyoӂ fyuӂ "
"ga    ge    gi    go    gu    gwa gwe gwi gwo "
"gwu gya gye gyi gyo gyu ha    he    hi    "
"ho    hu    hyaЂ hyeЂ hyiЂ hyoЂ hyuЂ i     ja  "
"je  ji    jo  ju  jya jye jyi jyo jyu "
"ka    ke    ki    ko    ku    kwa kya kye kyi "
"kyo kyu la    le    li    lka   lke   lo    ltsu  "
"ltu   lu    lwa   lya   lye   lyi   lyo   lyu   ma    "
"me    mi    mo    mu    mya݂ mye݂ myi݂ myo݂ myu݂ "
"n'    na    ne    ni    nn    no    nu    nyaɂ nyeɂ "
"nyiɂ nyoɂ nyuɂ o     pa    pe    pi    po    pu    "
"pya҂ pye҂ pyi҂ pyo҂ pyu҂ qa  qe  qi  qo  "
"qu    qwa qwe qwi qwo qwu qya qye qyi "
"qyo qyu ra    re    ri    ro    ru    rya rye肥 "
"ryi股 ryo ryu sa    se    sha she shi   sho "
"shu si    so    su    swa swe swi swo swu "
"sya sye syi syo syu ta    te    thaĂ theĂ "
"thiĂ thoĂ thuĂ ti    to    tsa tse tsi tso "
"tsu   tu    twaƂ tweƂ twiƂ twoƂ twuƂ tya tye "
"tyi tyo tyu u     va  ve  vi  vo  vu    "
"vya vye vyi vyo vyu wa    we  wha whe "
"whi who whu   wi  wo    wu    xa    xe    xi    "
"xka   xke   xn    xo    xtu   xtsu  xu    xwa   xya   "
"xye   xyi   xyo   xyu   ya    ye  yi    yo    yu    "
"za    ze    zi    zo    zu    zya zye zyi zyo "
"zyu ";

char IME_PATH97[]   = "Software\\Microsoft\\Ime\\msime97\\RomaDef";
char IME_PATH98[]   =
"Software\\Microsoft\\Windows\\CurrentVersion\\ime\\Japan\\ime98\\RomaDef";
char IME_PATH2000[] =
"Software\\Microsoft\\Windows\\CurrentVersion\\IME\\Japan\\IMEJP\\RomaDef";
char IME_PATH_OLD[] = "Software\\Microsoft\\IMEJP\\%d.%d";
char IME_PATH_NEW[] = "Software\\Microsoft\\IME\\%d.%d\\IMEJP";
char TSUKI_NAME[]   = NAME;
char TSUKI_DEF[]    = "\\RomaDef\\" NAME;
char BinData[10000];

int Kanji(int c) { return(c>128&&c<160)||(c>223&&c<253); }

int sortfunc(const void*a,const void*b)
{ return strcmp(*(const char**)a,*(const char**)b); }

int MakeData(UCHAR*str,int ime97,int test) {
    static UCHAR*table[4096],pool[10000],buf[10000];
    UCHAR*p,*q,*r; int i,num=0;
    /* ϊ\̃^uƑSp󔒂Ap̋󔒂ɕϊ */
    for (p=str;*p;p++) {
        if (Kanji(*p)) {
            if (p[0]==0x81&&p[1]==0x40) p[0]=p[1]=' ';
            p++;
        }
        if (*p=='\t') *p=' ';
    }
    /* 擪̋󔒂ǂݔ΂ */
    for (p=str;*p==' ';p++) ;

    /* z쐬 */
    for (q=pool;*p;) {
        table[num++]=q;
        while ((*p&128)==0) *q++=*p++;
        *q++='=';
        while (*p&&*p!=' ') *q++=*p++;
        while (*p&&*p==' ') p++;
        *q++=0;
    }

    /* zɃ\[g */
    qsort(table,num,sizeof(void*),sortfunc);

    /* ϊe[ũf[^쐬 */
    for (q=BinData,i=0;i<num;i++) {
        p=table[i];
        while (*p) *q++=*p++;
        *q++=0;
        if (ime97) *q++=0;
    }
    if (ime97==0) *q++=0;

    /* mF̂߁AzbZ[W{bNXƂĕ\ */
    if (test) {
        for (r=buf,i=0;i<num;i++) {
            for (p=table[i];*p;p++) *r++=*p;
            *r++='\t';
        }
        *r=0;
        MessageBoxA(0,buf,"",0);
    }

    /* ϊe[ȗ傫Ԃ */
    return q-BinData;
}

void SetTsuki(void) {
    int i,num,a,b,t[64],r; char s[64][256],w[256],buf[4096];
    HKEY h; DWORD d; int dsize,ro;

    buf[0]=0;
    num=0;
    if (RegOpenKeyExA(HKEY_CURRENT_USER,IME_PATH97,0,KEY_ALL_ACCESS,&h)==0)
    {
        if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
        lstrcpyA(s[num],IME_PATH97);
        lstrcatA(buf,IME_PATH97); lstrcatA(buf,"\r\n");
        t[num]=97;
        num++;
    }

    if (RegOpenKeyExA(HKEY_CURRENT_USER,IME_PATH98,0,KEY_ALL_ACCESS,&h)==0)
    {
        if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
        lstrcpyA(s[num],IME_PATH98);
        lstrcatA(buf,IME_PATH98); lstrcatA(buf,"\r\n");
        t[num]=98;
        num++;
    }

   if (RegOpenKeyExA(HKEY_CURRENT_USER,IME_PATH2000,0,KEY_ALL_ACCESS,&h)==0)
   {
        if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
        lstrcpyA(s[num],IME_PATH2000);
        lstrcatA(buf,IME_PATH2000); lstrcatA(buf,"\r\n");
        t[num]=2000;
        num++;
    }

    for (a=8;a<=24;a++) for (b=0;b<=2;b++) {
       if (a<=14) wsprintfA(w,IME_PATH_OLD,a,b);
       else       wsprintfA(w,IME_PATH_NEW,a,b);
       if (RegOpenKeyExA(HKEY_CURRENT_USER,w,0,KEY_ALL_ACCESS,&h)==0) {
           if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
           lstrcpyA(s[num],w);
           lstrcatA(buf,w); lstrcatA(buf,"\r\n");
           t[num]=a;
           num++;
       }
    }
    if (num==0)
    { MessageBoxA(0,"MS-IME ܂ł","",0); return; }
    lstrcatA(buf,"܂B");
    MessageBoxA(0,buf,"",0);
    for (i=0;i<num;i++) {
        w[0]=0;
        wsprintfA(buf,"%s %s ɔzݒ肵܂H",s[i],w);
        if (t[i]==97||t[i]==98) {
            wsprintfA(buf,"%s %s\n\nYes:݂Ȃz^No:[}zH",
                     s[i],w);
            r=MessageBoxA(0,buf,"",MB_YESNOCANCEL);
            if (r==IDCANCEL) continue;
            if (r==IDYES)    dsize=MakeData(MIZU_STR,t[i]==97,0);
            if (r==IDNO)     dsize=MakeData(ROMA_STR,t[i]==97,0);
            if (RegOpenKeyExA(HKEY_CURRENT_USER,s[i],0,KEY_ALL_ACCESS,&h))
            { MessageBoxA(0,"Opens","",0); return; }
            if (RegSetValueExA(h,"ROMA0",0,REG_BINARY,(LPBYTE)BinData,dsize))
            {
                MessageBoxA(0,"SetValues","",0);
                if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
                return;
            }
            if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
            MessageBoxA(0,
             "\n\n̐ݒ͂nrċNɗLɂȂ܂","",0);
        } else if (t[i]==2000) {
            if (MessageBoxA(0,buf,"",MB_YESNO)!=IDYES) continue;
            if (RegOpenKeyExA(HKEY_CURRENT_USER,s[i],0,KEY_ALL_ACCESS,&h))
            { MessageBoxA(0,"Opens","",0); return; }
            dsize=MakeData(MIZU_STR,0,0);
            if (RegSetValueExA(h,TSUKI_NAME,0,REG_BINARY,(LPBYTE)BinData,
                                                                   dsize)){
                MessageBoxA(0,"SetValues","",0);
                if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
                return;
            }
            if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
            MessageBoxA(0,
                "\n\nIMẼvpeBݒ肷ƗLɂȂ܂","",0);
        } else {
            if (MessageBoxA(0,buf,"",MB_YESNO)!=IDYES) continue;
            wsprintfA(buf,"%s%s",s[i],TSUKI_DEF);
            if (RegCreateKeyExA(HKEY_CURRENT_USER,buf,0,0,0,KEY_ALL_ACCESS,0,
                                 &h,&d))
            { MessageBoxA(0,"Creates","",0); return; }
            dsize=MakeData(MIZU_STR,0,0);
            if (RegSetValueExA(h,"table",0,REG_BINARY,(LPBYTE)BinData,
                                                                  dsize)) {
                MessageBoxA(0,"SetValues","",0);
                if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
                return;
            }
            if (RegCloseKey(h))
            { MessageBoxA(0,"Closes","",0); return; }
            MessageBoxA(0,
              "\n\nIMẼvpeBݒ肷ƗLɂȂ܂","",0);
        }
    }
}

void DelTsuki(void) {
    int i,j,k=0,num,a,b,t[64];
    char s[64][256],w[256]; static char buf[4096]; HKEY h; DWORD d;
    buf[0] = 0;
    num = 0;
   if (RegOpenKeyExA(HKEY_CURRENT_USER,IME_PATH2000,0,KEY_ALL_ACCESS,&h)==0)
   {
        if (RegQueryValueExA(h,TSUKI_NAME,0,&d,0,0)==0) {
            lstrcpyA(s[num],IME_PATH2000);
            lstrcatA(buf,IME_PATH2000); lstrcatA(buf,"\r\n");
            t[num]=2000;
            num++;
        }
        if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
    }

    for (a=8;a<=19;a++) for (b=0;b<=2;b++) {
       if (a<=14) wsprintfA(w,IME_PATH_OLD,a,b);
       else       wsprintfA(w,IME_PATH_NEW,a,b);
       lstrcatA(w,TSUKI_DEF);
       if (RegOpenKeyExA(HKEY_CURRENT_USER,w,0,KEY_ALL_ACCESS,&h)==0) {
           if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
           lstrcpyA(s[num],w);
           lstrcatA(buf,w); lstrcatA(buf,"\r\n");
           t[num]=a;
           num++;
       }
    }
    if (num==0) MessageBoxA(0,"݂Ȃz͂܂ł","",0);
    else {
        lstrcatA(buf,"ɂ݂Ȃz܂B");
        MessageBoxA(0,buf,"",0);
    }
    for (i=0;i<num;i++) {
        wsprintfA(w,"%s\n\n݂̂Ȃz폜܂H\n\n"
                    "(݂ȂzIĂꍇ͍폜Ȃł)",
                    s[i]);
        if (MessageBoxA(0,w,"",MB_YESNO)==IDYES) {
            if (t[i]==2000) {
              if (RegOpenKeyExA(HKEY_CURRENT_USER,s[i],0,KEY_ALL_ACCESS,&h))
              { MessageBoxA(0,"Opens","",0); return; }     
              if (RegDeleteValueA(h,TSUKI_NAME)) {
                  MessageBoxA(0,"DeleteValues","",0);
                  if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
                  return;
              }
            } else {
              if (RegOpenKeyExA(HKEY_CURRENT_USER,s[i],0,KEY_ALL_ACCESS,&h))
              { MessageBoxA(0,"Opens","",0); return; }     
              if (RegDeleteValueA(h,"table")) {
                  MessageBoxA(0,"DeleteValues","",0);
                  if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
                  return;
              }
             if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
             lstrcpyA(w,s[i]);
             for (j=0;w[j];j++) if (w[j]=='\\') k=j;
             w[k]=0;
             if (RegOpenKeyExA(HKEY_CURRENT_USER,w,0,KEY_ALL_ACCESS,&h))
             { MessageBoxA(0,"Opens(2)","",0); return; }     
             if (RegDeleteKeyA(h,TSUKI_NAME)) {
                  MessageBoxA(0,"DeleteKeys","",0);
                  if (RegCloseKey(h)) MessageBoxA(0,"Closes","",0);
                  return;
             }
           }
           if (RegCloseKey(h)) { MessageBoxA(0,"Closes","",0); return; }
           MessageBoxA(0,"","",0);
       }
    }
}

int main(void) {
    MakeData(MIZU_STR,0,1);
    if (MessageBoxA(0,"zݒ肵܂H\r\n\r\n"
        "(IME97,IME98 [}ɖ߂Ƃu͂vIт܂)",
        "",MB_YESNO)==IDYES) SetTsuki();
    else if (MessageBoxA(0,"z폜܂H\r\n\r\n"
        "(ʏA폜ȂĂ肠܂)"
             ,"",MB_YESNO)==IDYES)
        DelTsuki();
    return 0;
}

